/*******************************************************************************
 * Copyright (c) 2006 Oracle Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Cameron Bateman/Oracle - initial API and implementation
 *    
 ********************************************************************************/

package org.eclipse.jst.jsf.designtime.internal.provisional.el;

import org.eclipse.jst.jsf.context.symbol.internal.provisional.ISymbol;

/**
 * Super-class of all design time property resolvers
 * 
 * @author cbateman
 *
 */
public abstract class AbstractDTPropertyResolver 
{
    /**
     * Returns a symbol encapsulating the property on base with the name
     * properyId
     * 
     * @param base
     * @param propertyId
     * @return the symbol for the named propertyId or null if not found
     */
    public abstract ISymbol getProperty(ISymbol base, Object propertyId);
    
    /**
     * @param base
     * @return all properties of base
     */
    public abstract ISymbol[] getAllProperties(ISymbol base);
}
