/*******************************************************************************
 * Copyright (c) 2004, 2005 Sybase, Inc. and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Sybase, Inc. - initial API and implementation
 *******************************************************************************/

package org.eclipse.jst.jsf.facesconfig.common.dialogfield;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.jst.jsf.facesconfig.common.CommonPlugin;
import org.eclipse.jst.jsf.facesconfig.common.logging.Logger;
import org.eclipse.jst.jsf.facesconfig.common.utils.ResourceUtils;


/**
 * Resource bundle class for datastore wizard and it's pages
 * 
 * @author Xiao-guang Zhang
 */
public class DialogFieldResources extends ResourceUtils {
	/** Create the logger for this class */
	private static Logger log = CommonPlugin
			.getLogger(DialogFieldResources.class);

	private static DialogFieldResources resource; // singleton

	private static final String BUNDLE = DialogFieldResources.class.getName(); //$NON-NLS-1$

	/**
	 * Empty Constructor.
	 * 
	 * @return WizardsResources
	 */

	public static DialogFieldResources getInstance() {
		if (resource == null) {
			resource = new DialogFieldResources();
		}
		return resource;
	}

	/**
	 * The constructor create a resource bundle
	 */
	protected DialogFieldResources() {
		try {
			resources = ResourceBundle.getBundle(BUNDLE);
			// NOTE: this throws a runtime "MissingResourceException".
		} catch (MissingResourceException ee) {
			// Wizards.WizardResource.Error.ResourceNotFound = Unable to locate
			// resource.
			log.error("Wizards.WizardResource.Error.ResourceNotFound", ee); //$NON-NLS-1$
		}
		setBundle(resources, BUNDLE);
	}
}
