/*******************************************************************************
 * Copyright (c) 2004, 2005 Sybase, Inc. and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Sybase, Inc. - initial API and implementation
 *******************************************************************************/
package org.eclipse.jst.jsf.facesconfig.common.dialogfield;

import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.forms.widgets.FormToolkit;

/**
 * The text input only allows numbers
 * 
 * @author mengbo
 * @version 1.0
 */
public class NumberDialogField extends StringDialogField {
	private final String REGULAR_EXPRESSION = "[\\-0-9]*";

	public Control[] doFillIntoGrid(FormToolkit kit, Composite parent,
			int nColumns) {
		Control[] controls = super.doFillIntoGrid(kit, parent, nColumns);

		getTextControl(kit, parent).addVerifyListener(new VerifyListener() {
			public void verifyText(VerifyEvent e) {
				e.doit = e.text.matches(REGULAR_EXPRESSION);
			}
		});

		return controls;
	}
}
